# State File Reference

`#include <osg/Export>`
`#include <osg/StateSet>`
`#include <osg/Matrix>`
`#include <osg/FrameStamp>`
`#include <osg/DisplaySettings>`
`#include <osg/Polytope>`
`#include <osg/Viewport>`
`#include <vector>`
`#include <map>`

Include dependency graph for State:

This graph shows which files directly or indirectly include this file:

## Namespaces

namespace | osg

## Defines

#define | OSG_STATE 1
#define | GL_TEXTURE0 0x84C0
#define | GL_FOG_COORDINATE_ARRAY 0x8457
#define | GL_SECONDARY_COLOR_ARRAY 0x845E
#define | OSG_GL_DEBUG(message)
| macro for use with osg::StateAttribute::apply methods for detecting and reporting OpenGL error messages.

## Define Documentation

#define GL_FOG_COORDINATE_ARRAY 0x8457

#define GL_SECONDARY_COLOR_ARRAY 0x845E

#define GL_TEXTURE0 0x84C0

#define OSG_GL_DEBUG | ( | message |  | ) |

Value:

    if (state.getFineGrainedErrorDetection()) \
        { \
            GLenum errorNo = glGetError(); \
            if (errorNo!=GL_NO_ERROR) \
            { \
                osg::notify(WARN)<<"Warning: detected OpenGL error '"<<gluErrorString(errorNo)<<" "<<message<<endl; \
            }\
        }

macro for use with osg::StateAttribute::apply methods for detecting and reporting OpenGL error messages.

#define OSG_STATE 1